## lnav 0.12.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

include(cmake/prelude.cmake)

set(CMAKE_CXX_STANDARD 17)
project(
        lnav
        VERSION 0.12.3
        DESCRIPTION "An advanced log file viewer for the terminal."
        HOMEPAGE_URL "https://lnav.org/"
        LANGUAGES CXX C
)

include(cmake/project-is-top-level.cmake)
include(cmake/variables.cmake)

set(CURSES_NEED_NCURSES TRUE)
find_package(PkgConfig REQUIRED)
find_package(unofficial-sqlite3 CONFIG REQUIRED)
find_package(BZip2 REQUIRED)
find_package(LibArchive REQUIRED)
find_package(ZLIB REQUIRED)
find_package(pcre2 CONFIG REQUIRED)
pkg_check_modules(readline REQUIRED IMPORTED_TARGET readline)
find_package(Curses REQUIRED)
find_package(CURL REQUIRED)

set(lnav_LIBS
        CURL::libcurl
        unofficial::sqlite3::sqlite3
        BZip2::BZip2
        ${CURSES_LIBRARIES}
        PCRE2::8BIT PCRE2::16BIT PCRE2::32BIT PCRE2::POSIX
        PkgConfig::readline
        LibArchive::LibArchive
        ZLIB::ZLIB
)

add_subdirectory(src)
add_subdirectory(test)

# ---- Install rules ----

if (NOT CMAKE_SKIP_INSTALL_RULES)
    include(cmake/install-rules.cmake)
endif ()

# ---- Developer mode ----

if (NOT lnav_DEVELOPER_MODE)
    return()
elseif (NOT PROJECT_IS_TOP_LEVEL)
    message(
            AUTHOR_WARNING
            "Developer mode is intended for developers of lnav"
    )
endif ()

include(cmake/dev-mode.cmake)

=== crashd/requirements.txt ===
blinker==1.8.2
click==8.1.7
Flask==3.0.3
gunicorn==22.0.0
itsdangerous==2.2.0
Jinja2==3.1.4
MarkupSafe==2.1.5
packaging==24.0
spookyhash==2.1.0
Werkzeug==3.0.6

=== docs/requirements.txt ===
furo
sphinx>=4.3.0
sphinx-copybutton
sphinx-jsonschema
sphinx-prompt
pathlib
sphinx-rtd-theme>=0.5.1

=== release/Makefile ===

VERSION=0.12.3

VERSION_TAG=v$(VERSION)

SRC_VERSION=master

outbox:
	mkdir -p $@

clean-outbox: outbox
	rm -f outbox/*

PACKAGE_URLS = \
	https://www.libarchive.org/downloads/libarchive-3.6.2.tar.gz \
	https://ftp.gnu.org/gnu/make/make-4.2.1.tar.gz \
	ftp://ftp.gnu.org/gnu/ncurses/ncurses-6.4.tar.gz \
	https://github.com/PCRE2Project/pcre2/releases/download/pcre2-10.42/pcre2-10.42.tar.gz \
	https://ftp.gnu.org/gnu/readline/readline-6.3.tar.gz \
	https://zlib.net/zlib-1.2.13.tar.gz \
	https://sourceware.org/pub/bzip2/bzip2-1.0.8.tar.gz \
	https://www.sqlite.org/2023/sqlite-autoconf-3420000.tar.gz \
	https://www.openssl.org/source/openssl-1.0.2n.tar.gz \
	https://www.libssh2.org/download/libssh2-1.11.0.tar.gz \
	https://curl.se/download/curl-8.1.2.tar.gz \
	https://tukaani.org/xz/xz-5.4.3.tar.gz

.PHONY: linux freebsd pkger download-pkgs musl

%-vm: %
	cd vagrant-static && vagrant up $<

download-pkgs:
	mkdir -p vagrant-static/pkgs && cd vagrant-static/pkgs && \
	for pkg in $(PACKAGE_URLS); do \
		if ! wget -N $${pkg}; then \
		  exit 1; \
		fi \
	done

%-build: % %-vm
	cd vagrant-static && vagrant ssh $< -c "/vagrant/build.sh ${SRC_VERSION}"

%-package: % clean-outbox %-build
	mkdir -p $<-pkg/lnav-${VERSION}
	cp ../README ../NEWS.md $<-pkg/lnav-${VERSION}
	mv vagrant-static/lnav $<-pkg/lnav-${VERSION}
	cd $<-pkg && zip -r ../outbox/lnav-${VERSION}-x86_64-linux-$<.zip lnav-${VERSION}
	rm -rf $<-pkg

linux-ospkg: pkger-vm linux-package
	rm -f vagrant-static/lnav\*.deb vagrant-static/lnav\*.rpm
	cd vagrant-static && vagrant ssh pkger -c "/vagrant/build-pkg.sh ${VERSION}"
	mv vagrant-static/lnav*.deb vagrant-static/lnav*.rpm outbox/

osx-build:
	rm -rf osx-build-dir
	mkdir -p osx-build-dir
	cd ../ && ./autogen.sh
	cd osx-build-dir && \
	  ../../configure --enable-static \
	  --with-readline=/usr/local/opt/readline \
	  --with-sqlite3=/usr/local/opt/sqlite \
	  --with-libarchive=/usr/local/opt/libarchive \
	  "CXXFLAGS=-I/usr/local/opt/ncurses/include -g1 -O2" \
	  "CFLAGS=-I/usr/local/opt/ncurses/include -g1 -O2" \
	  "LDFLAGS=-L/usr/local/opt/ncurses/lib -L/usr/local/opt/xz/lib" \
	  "LIBS=-llzma -lzstd -lbrotlidec-static -liconv -llz4" \
	  && make -j8 && make dist -j8 && make dist-bzip2

osx-package: clean-outbox osx-build
	mkdir -p osx-pkg/lnav-${VERSION}
	git pull --rebase
	cp ../README ../NEWS.md osx-pkg/lnav-${VERSION}
	cp osx-build-dir/src/lnav osx-pkg/lnav-${VERSION}
	cp osx-build-dir/lnav-${VERSION}.tar.gz outbox/
	cp osx-build-dir/lnav-${VERSION}.tar.bz2 outbox/
	cd osx-pkg && zip -r ../outbox/lnav-${VERSION}-x86_64-macos.zip lnav-${VERSION}
	rm -rf osx-pkg

release-NEWS.md: ../NEWS.md
	sed -n "/^## lnav v${VERSION}/,/^## /p" $< | sed '$$d' > $@

release-tag: release-NEWS.md
	gh release create ${VERSION_TAG} \
		-d \
		-t "lnav v${VERSION}" \
		--notes-file release-NEWS.md

release: osx-package musl-package release-NEWS.md
	gh release edit ${VERSION_TAG} \
		-t "lnav v${VERSION}" \
		--notes-file release-NEWS.md
	gh release upload ${VERSION_TAG} outbox/*

push:
	env LANG=UTF-8 package_cloud push tstack/lnav/ubuntu/lucid outbox/lnav*.deb
	env LANG=UTF-8 package_cloud push tstack/lnav/el/5 outbox/lnav-0.12.1-1.x86_64.rpm

clean:
	cd vagrant-static && vagrant destroy -f
	rm -rf vagrant-static/pkgs

lnav.spec: lnav.spec.in makespec.sh
	./makespec.sh < lnav.spec.in > $@

=== src/CMakeLists.txt ===
include(CheckTypeSize)
include(CheckIncludeFile)
include(CheckLibraryExists)
include(CheckFunctionExists)

check_type_size(off_t SIZEOF_OFF_T)

check_include_file("pty.h" HAVE_PTY_H)
check_include_file("util.h" HAVE_UTIL_H)
check_include_file("execinfo.h" HAVE_EXECINFO_H)

set(VCS_PACKAGE_STRING "lnav ${CMAKE_PROJECT_VERSION}")
set(PACKAGE_VERSION "${CMAKE_PROJECT_VERSION}")

configure_file(config.cmake.h.in config.h)

add_subdirectory(base)
add_subdirectory(pcrepp)
add_subdirectory(remote)
add_subdirectory(tailer)
add_subdirectory(formats/logfmt)
add_subdirectory(yajl)
add_subdirectory(yajlpp)

add_executable(bin2c bin2c.hh ../tools/bin2c.c)
target_link_libraries(bin2c ZLIB::ZLIB)

add_executable(ptimec ptimec.hh ptimec.c)

set(TIME_FORMATS
        "@%@"
        "%Y-%m-%d %H:%M:%S.%f%z"
        "%Y-%m-%d %H:%M:%S,%f%z"
        "%Y-%m-%d %H:%M:%S.%f %Z"
        "%Y-%m-%d %H:%M:%S,%f %Z"
        "%Y-%m-%d %H:%M:%S,%L%z"
        "%Y-%m-%d %H:%M:%S,%L %z"
        "%Y-%m-%d %H:%M:%S.%L%z"
        "%Y-%m-%d %H:%M:%S.%L %z"
        "%Y-%m-%d %H:%M:%S.%L %Z"
        "%Y-%m-%d %H:%M:%S,%L"
        "%Y-%m-%d %H:%M:%S.%L"
        "%Y-%m-%d %H:%M:%S%z"
        "%Y-%m-%d %H:%M:%S %Z"
        "%Y-%m-%d %H:%M:%S %z"
        "%Y-%m-%d %H:%M:%S:%L"
        "%Y-%m-%d %H:%M:%S"
        "%Y-%m-%d %H:%M"
        "%Y-%jT%H:%M:%S %p %Z"
        "%Y-%m-%dT%H:%M:%S %p %Z"
        "%Y-%jT%H:%M:%S.%N%z"
        "%Y-%m-%dT%H:%M:%S.%N%z"
        "%y-%m-%dT%H:%M:%S.%N%z"
        "%Y-%jT%H:%M:%S.%f%z"
        "%Y-%m-%dT%H:%M:%S.%f%z"
        "%y-%m-%dT%H:%M:%S.%f%z"
        "%Y-%jT%H:%M:%S.%L%z"
        "%Y-%m-%dT%H:%M:%S.%L%z"
        "%y-%m-%dT%H:%M:%S.%L%z"
        "%Y-%jT%H:%M:%S.%L%Z"
        "%Y-%m-%dT%H:%M:%S.%L%Z"
        "%y-%m-%dT%H:%M:%S.%L%Z"
        "%Y-%m-%dT%H:%M:%S%z"
        "%Y-%m-%dT%H:%M:%S%z"
        "%Y-%m-%dT%H:%M:%S"
        "%Y-%m-%dT%H:%M"
        "%Y/%m/%d %H:%M:%S %z"
        "%Y/%m/%d %H:%M:%S%z"
        "%Y/%m/%d %H:%M:%S.%f%z"
        "%Y/%m/%d %H:%M:%S.%f%Z"
        "%Y/%m/%d %H:%M:%S.%f %z"
        "%Y/%m/%d %H:%M:%S.%f %Z"
        "%Y/%m/%d %H:%M:%S.%f"
        "%Y/%m/%d %H:%M:%S.%L"
        "%Y/%m/%d %H:%M:%S"
        "%Y/%m/%d %H:%M"
        "%Y %b %d %a %H:%M:%S.%L"
        "%Y %b %d %H:%M:%S.%L"
        "%Y %b %d %H:%M:%S"
        "%a %b %d %H:%M:%S %Y"
        "%a %b %d %H:%M:%S.%f %Y"
        "%a %b %d %H:%M:%S:%f %Y"
        "%a %b %d %H:%M:%S %Z %Y"
        "%a %b %d %I:%M:%S %p %Z %Y"
        "%a %b %d %H:%M:%S "
        "%a %b %d %H:%M:%S.%L "
        "%a %b %d %H:%M "
        "%a %b %e %H:%M:%S %Z %Y"
        "%d/%b/%Y:%H:%M:%S %z"
        "%d-%b-%Y %H:%M:%S %z"
        "%d-%b-%Y %H:%M:%S %Z"
        "%d %b %Y %H:%M:%S"
        "%d %b %Y %H:%M:%S.%L%z"
        "%d %b %Y %H:%M:%S,%L%z"
        "%d %b %Y %H:%M:%S.%L"
        "%d %b %Y %H:%M:%S,%L"
        "%d %b %Y %H:%M"
        "%b-%d %H:%M:%S"
        "%b %d %H:%M:%S"
        "%b %d %k:%M:%S"
        "%b %d %l:%M:%S"
        "%b %d %l:%M"
        "%b %e, %Y %l:%M:%S %p"
        "%b %d, %Y %l:%M:%S %p"
        "%m/%d/%Y %I:%M:%S:%L %p %Z"
        "%m/%d/%Y %I:%M:%S %p %Z"
        "%m/%d/%Y %l:%M:%S %p %Z"
        "%m/%d/%Y %I:%M:%S %p%z"
        "%m/%d/%Y %l:%M:%S %p%z"
        "%m/%e/%Y %l:%M:%S %p%z"
        "%m/%e/%Y %l:%M:%S %p %z"
        "%m/%e/%Y %I:%M:%S %p"
        "%m/%e/%Y %l:%M:%S%p"
        "%m/%d/%y %H:%M:%S"
        "%m/%d/%Y %H:%M:%S"
        "%d/%b/%Y %H:%M:%S"
        "%d/%b/%y %H:%M:%S"
        "%m%d %H:%M:%S"
        "%Y%m%d %H:%M:%S"
        "%Y%m%d.%H%M%S"
        "%H:%M:%S"
        "%H:%M:%S.%f"
        "%M:%S"
        "%m/%d %H:%M:%S"
        "%Y-%m-%d"
        "%Y-%m"
        "%Y/%m/%d"
        "%Y/%m"
        "%s.%f"

)

set(GEN_SRCS "")

add_custom_command(OUTPUT time_fmts.cc COMMAND ptimec ${TIME_FORMATS} >
        time_fmts.cc)

add_library(lnavdt STATIC config.h.in ptimec.hh ptimec_rt.cc time_fmts.cc)
target_include_directories(lnavdt PUBLIC . ${CMAKE_CURRENT_BINARY_DIR} third-party/date/include)

function(bin2c)
    cmake_parse_arguments(BIN2C_ "" "VARNAME" "" ${ARGN})

    list(TRANSFORM BIN2C_UNPARSED_ARGUMENTS "\\." "-")
    add_custom_command(
            OUTPUT "${DST_FILE}.h" "${DST_FILE}.cc"
            COMMAND bin2c "${DST_FILE}" "${CMAKE_CURRENT_SOURCE_DIR}/${FILE_TO_LINK}"
            DEPENDS bin2c "${FILE_TO_LINK}")
endfunction(bin2c)

foreach (FILE_TO_LINK animals.json ansi-palette.json css-color-names.json diseases.json emojis.json xml-entities.json xterm-palette.json help.txt help.md init.sql words.json)
    string(REPLACE "." "-" DST_FILE "${FILE_TO_LINK}")
    add_custom_command(
            OUTPUT "${DST_FILE}.h" "${DST_FILE}.cc"
            COMMAND bin2c "${DST_FILE}" "${CMAKE_CURRENT_SOURCE_DIR}/${FILE_TO_LINK}"
            DEPENDS bin2c "${FILE_TO_LINK}")
    list(APPEND GEN_SRCS "${CMAKE_CURRENT_BINARY_DIR}/${DST_FILE}.h"
            "${CMAKE_CURRENT_BINARY_DIR}/${DST_FILE}.cc")
endforeach (FILE_TO_LINK)

set(FORMAT_FILES
        formats/access_log.json
        formats/alb_log.json
        formats/block_log.json
        formats/bunyan_log.json
        formats/candlepin_log.json
        formats/choose_repo_log.json
        formats/cloudflare_log.json
        formats/cloudvm_ram_log.json
        formats/cups_log.json
        formats/dpkg_log.json
        formats/elb_log.json
        formats/engine_log.json
        formats/error_log.json
        formats/esx_syslog_log.json
        formats/fsck_hfs_log.json
        formats/github_events_log.json
        formats/glog_log.json
        formats/haproxy_log.json
        formats/java_log.json
        formats/journald_json_log.json
        formats/katello_log.json
        formats/lnav_debug_log.json
        formats/nextcloud_log.json
        formats/nextflow_log.json
        formats/openam_log.json
        formats/openamdb_log.json
        formats/openstack_log.json
        formats/page_log.json
        formats/pcap_log.json
        formats/procstate_log.json
        formats/redis_log.json
        formats/snaplogic_log.json
        formats/sssd_log.json
        formats/strace_log.json
        formats/sudo_log.json
        formats/syslog_log.json
        formats/s3_log.json
        formats/tcf_log.json
        formats/tcsh_history.json
        formats/unifi_log.json
        formats/uwsgi_log.json
        formats/vdsm_log.json
        formats/vmk_log.json
        formats/vmw_log.json
        formats/vmw_vc_svc_log.json
        formats/vmw_py_log.json
        formats/vpostgres_log.json
        formats/xmlrpc_log.json
        formats/zookeeper_log.json
)

set(FORMAT_FILE_PATHS ${FORMAT_FILES})

list(TRANSFORM FORMAT_FILE_PATHS PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")

add_custom_command(
        OUTPUT default-formats.h default-formats.cc
        COMMAND bin2c -n lnav_format_json default-formats ${FORMAT_FILE_PATHS}
        DEPENDS bin2c ${FORMAT_FILES})
list(APPEND GEN_SRCS default-formats.h default-formats.cc)

set(PRQL_FILES
        prql/stats.prql
        prql/utils.prql)

set(PRQL_FILE_PATHS ${PRQL_FILES})

list(TRANSFORM PRQL_FILE_PATHS PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")

add_custom_command(
        OUTPUT prql-modules.h prql-modules.cc
        COMMAND bin2c -n lnav_prql_modules prql-modules ${PRQL_FILE_PATHS}
        DEPENDS bin2c ${PRQL_FILES})
list(APPEND GEN_SRCS prql-modules.h prql-modules.cc)

set(CONFIG_FILES
        root-config.json
        keymaps/de-keymap.json
        keymaps/default-keymap.json
        keymaps/fr-keymap.json
        keymaps/uk-keymap.json
        keymaps/us-keymap.json
        themes/default-theme.json
        themes/grayscale.json
        themes/eldar.json
        themes/monocai.json
        themes/night-owl.json
        themes/solarized-dark.json
        themes/solarized-light.json)

set(CONFIG_FILE_PATHS ${CONFIG_FILES})

list(TRANSFORM CONFIG_FILE_PATHS PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")

add_custom_command(
        OUTPUT default-config.h default-config.cc
        COMMAND bin2c -n lnav_config_json default-config ${CONFIG_FILE_PATHS}
        DEPENDS bin2c ${CONFIG_FILES})
list(APPEND GEN_SRCS default-config.h default-config.cc)

set(BUILTIN_LNAV_SCRIPTS
        scripts/dhclient-summary.lnav
        scripts/docker-url-handler.lnav
        scripts/journald-url-handler.lnav
        scripts/lnav-pop-view.lnav
        scripts/partition-by-boot.lnav
        scripts/piper-url-handler.lnav
        scripts/rename-stdin.lnav
        scripts/search-for.lnav
)

set(BUILTIN_LNAV_SCRIPT_PATHS ${BUILTIN_LNAV_SCRIPTS})

list(TRANSFORM BUILTIN_LNAV_SCRIPT_PATHS PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")

add_custom_command(
        OUTPUT builtin-scripts.h builtin-scripts.cc
        COMMAND bin2c -n lnav_scripts builtin-scripts ${BUILTIN_LNAV_SCRIPT_PATHS}
        DEPENDS bin2c ${BUILTIN_LNAV_SCRIPTS})
list(APPEND GEN_SRCS builtin-scripts.h builtin-scripts.cc)

set(BUILTIN_SH_SCRIPTS scripts/com.vmware.btresolver.py scripts/dump-pid.sh scripts/pcap_log-converter.sh)

set(BUILTIN_SH_SCRIPT_PATHS ${BUILTIN_SH_SCRIPTS})

list(TRANSFORM BUILTIN_SH_SCRIPT_PATHS PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")

add_custom_command(
        OUTPUT builtin-sh-scripts.h builtin-sh-scripts.cc
        COMMAND bin2c -n lnav_sh_scripts builtin-sh-scripts ${BUILTIN_SH_SCRIPT_PATHS}
        DEPENDS bin2c ${BUILTIN_SH_SCRIPTS})
list(APPEND GEN_SRCS builtin-sh-scripts.h builtin-sh-scripts.cc)

add_library(
        cppfmt STATIC
        fmtlib/format.cc
        fmtlib/os.cc
        fmtlib/fmt/args.h
        fmtlib/fmt/chrono.h
        fmtlib/fmt/color.h
        fmtlib/fmt/compile.h
        fmtlib/fmt/core.h
        fmtlib/fmt/format-inl.h
        fmtlib/fmt/format.h
        fmtlib/fmt/locale.h
        fmtlib/fmt/os.h
        fmtlib/fmt/ostream.h
        fmtlib/fmt/printf.h
        fmtlib/fmt/ranges.h
        fmtlib/fmt/std.h
        fmtlib/fmt/xchar.h
)
target_include_directories(cppfmt PUBLIC fmtlib)

add_library(
        datepp STATIC
        third-party/date/src/tz.cpp
)
target_include_directories(datepp PUBLIC third-party/date/include)
target_link_libraries(datepp ${lnav_LIBS})

add_library(
        cppscnlib STATIC
        third-party/scnlib/src/reader_float.cpp
        third-party/scnlib/src/reader_int.cpp
        third-party/scnlib/src/locale.cpp
        third-party/scnlib/src/file.cpp
        third-party/scnlib/src/vscan.cpp

        third-party/scnlib/include/scn/reader/reader.h
        third-party/scnlib/include/scn/reader/float.h
        third-party/scnlib/include/scn/reader/types.h
        third-party/scnlib/include/scn/reader/int.h
        third-party/scnlib/include/scn/reader/common.h
        third-party/scnlib/include/scn/reader/string.h
        third-party/scnlib/include/scn/ranges/custom_impl.h
        third-party/scnlib/include/scn/ranges/std_impl.h
        third-party/scnlib/include/scn/ranges/ranges.h
        third-party/scnlib/include/scn/ranges/util.h
        third-party/scnlib/include/scn/fwd.h
        third-party/scnlib/include/scn/util/algorithm.h
        third-party/scnlib/include/scn/util/small_vector.h
        third-party/scnlib/include/scn/util/optional.h
        third-party/scnlib/include/scn/util/expected.h
        third-party/scnlib/include/scn/util/array.h
        third-party/scnlib/include/scn/util/unique_ptr.h
        third-party/scnlib/include/scn/util/math.h
        third-party/scnlib/include/scn/util/memory.h
        third-party/scnlib/include/scn/util/span.h
        third-party/scnlib/include/scn/util/meta.h
        third-party/scnlib/include/scn/util/string_view.h
        third-party/scnlib/include/scn/unicode/unicode.h
        third-party/scnlib/include/scn/unicode/common.h
        third-party/scnlib/include/scn/unicode/utf16.h
        third-party/scnlib/include/scn/unicode/utf8.h
        third-party/scnlib/include/scn/all.h
        third-party/scnlib/include/scn/tuple_return/tuple_return.h
        third-party/scnlib/include/scn/tuple_return/util.h
        third-party/scnlib/include/scn/scan/ignore.h
        third-party/scnlib/include/scn/scan/getline.h

=== test/CMakeLists.txt ===
enable_testing()

include_directories(
        . ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/fmtlib
        ${CMAKE_SOURCE_DIR}/src/third-party/date/include
        ${CMAKE_CURRENT_BINARY_DIR}/../src ${CMAKE_CURRENT_BINARY_DIR})

add_executable(test_abbrev test_abbrev.cc test_stubs.cc)
target_link_libraries(test_abbrev diag)
add_test(NAME test_abbrev COMMAND test_abbrev)

add_executable(test_ansi_scrubber test_ansi_scrubber.cc test_stubs.cc)
target_link_libraries(test_ansi_scrubber diag)
add_test(NAME test_ansi_scrubber COMMAND test_ansi_scrubber)

add_executable(test_auto_fd test_auto_fd.cc test_stubs.cc)
target_link_libraries(test_auto_fd diag)
add_test(NAME test_auto_fd COMMAND test_auto_fd)

add_executable(test_auto_mem test_auto_mem.cc test_stubs.cc)
target_link_libraries(test_auto_mem diag)
add_test(NAME test_auto_mem COMMAND test_auto_mem)

add_executable(test_column_namer test_column_namer.cc test_stubs.cc)
target_include_directories(test_column_namer PUBLIC ../src/third-party/doctest-root)
target_link_libraries(test_column_namer diag)
add_test(NAME test_column_namer COMMAND test_column_namer)

add_executable(document.sections.tests document.sections.tests.cc test_stubs.cc)
target_include_directories(document.sections.tests PUBLIC ../src/third-party/doctest-root)
target_link_libraries(document.sections.tests diag)
add_test(NAME document.sections.tests COMMAND document.sections.tests)

add_executable(test_bookmarks test_bookmarks.cc test_stubs.cc)
target_link_libraries(test_bookmarks diag)
add_test(NAME test_bookmarks COMMAND test_bookmarks)

add_executable(test_date_time_scanner test_date_time_scanner.cc)
target_include_directories(test_date_time_scanner PUBLIC ../src/third-party/doctest-root)
target_link_libraries(test_date_time_scanner base lnavdt diag)
add_test(NAME test_date_time_scanner COMMAND test_date_time_scanner)

add_executable(test_grep_proc2 test_grep_proc2.cc)
target_link_libraries(test_grep_proc2 lnavfileio)
add_test(NAME test_grep_proc2 COMMAND test_grep_proc2)

add_executable(test_line_buffer2 test_line_buffer2.cc)
target_link_libraries(test_line_buffer2 lnavfileio)
add_test(NAME test_line_buffer2 COMMAND test_line_buffer2)

add_executable(test_log_accel test_log_accel.cc test_stubs.cc)
target_link_libraries(test_log_accel diag)
add_test(NAME test_log_accel COMMAND test_log_accel)

add_executable(lnav_doctests lnav_doctests.cc test_stubs.cc)
target_include_directories(lnav_doctests PUBLIC ../src/third-party/doctest-root)
target_link_libraries(lnav_doctests diag ${lnav_LIBS})
add_test(NAME lnav_doctests COMMAND lnav_doctests)

add_executable(test_reltime test_reltime.cc test_stubs.cc)
target_include_directories(test_reltime PUBLIC ../src/third-party/doctest-root)
target_link_libraries(test_reltime diag)
add_test(NAME test_reltime COMMAND test_reltime)

add_executable(test_top_status test_top_status.cc test_stubs.cc)
target_link_libraries(test_top_status diag logfmt)
add_test(NAME test_top_status COMMAND test_top_status)

add_executable(test_text_anonymizer test_text_anonymizer.cc test_stubs.cc)
target_include_directories(test_text_anonymizer PUBLIC ../src/third-party/doctest-root)
target_link_libraries(test_text_anonymizer diag)
add_test(NAME test_text_anonymizer COMMAND test_text_anonymizer)

add_executable(drive_view_colors drive_view_colors.cc test_stubs.cc)
target_link_libraries(drive_view_colors diag)

add_executable(drive_vt52_curses drive_vt52_curses.cc test_stubs.cc)
target_link_libraries(drive_vt52_curses diag)

add_executable(drive_logfile drive_logfile.cc test_stubs.cc)
target_link_libraries(drive_logfile diag)

add_executable(drive_sql_anno drive_sql_anno.cc test_stubs.cc)
target_link_libraries(drive_sql_anno diag)

add_executable(drive_data_scanner drive_data_scanner.cc test_stubs.cc)
target_link_libraries(drive_data_scanner diag logfmt)

add_executable(drive_doc_discovery drive_doc_discovery.cc test_stubs.cc)
target_link_libraries(drive_doc_discovery diag logfmt)

add_executable(scripty scripty.cc test_stubs.cc)
target_link_libraries(scripty diag)

=== src/base/CMakeLists.txt ===
add_library(
        base STATIC
        ../config.h.in
        ansi_scrubber.cc
        attr_line.cc
        attr_line.builder.cc
        auto_fd.cc
        auto_pid.cc
        color_spaces.cc
        date_time_scanner.cc
        fs_util.cc
        humanize.cc
        humanize.network.cc
        humanize.time.cc
        intern_string.cc
        is_utf8.cc
        isc.cc
        lnav.console.cc
        lnav.gzip.cc
        lnav_log.cc
        network.tcp.cc
        paths.cc
        piper.file.cc
        snippet_highlighters.cc
        string_attr_type.cc
        string_util.cc
        strnatcmp.c
        time_util.cc

        ansi_scrubber.hh
        ansi_vars.hh
        attr_line.hh
        attr_line.builder.hh
        auto_fd.hh
        auto_mem.hh
        auto_pid.hh
        bus.hh
        color_spaces.hh
        date_time_scanner.cfg.hh
        date_time_scanner.hh
        enum_util.hh
        from_trait.hh
        fs_util.hh
        func_util.hh
        future_util.hh
        humanize.hh
        humanize.network.hh
        humanize.time.hh
        injector.hh
        injector.bind.hh
        intern_string.hh
        is_utf8.hh
        isc.hh
        itertools.hh
        itertools.enumerate.hh
        keycodes.hh
        line_range.hh
        lnav.console.hh
        lnav.console.into.hh
        log_level_enum.hh
        lrucache.hpp
        map_util.hh
        math_util.hh
        network.tcp.hh
        paths.hh
        piper.file.hh
        result.h
        snippet_highlighters.hh
        string_attr_type.hh
        strnatcmp.h
        time_util.hh
        types.hh
        wcwidth9.h

        ../third-party/xxHash/xxhash.h
        ../third-party/xxHash/xxhash.c
)

target_include_directories(base PUBLIC . .. ../third-party
        ../third-party/date/include
        ${CURSES_INCLUDE_DIRS}
        ${CMAKE_CURRENT_BINARY_DIR}/..)
target_link_libraries(base
        cppfmt
        cppscnlib
        pcrepp
        ${CURSES_LIBRARIES}
        pthread
        lnavdt
        datepp)

add_executable(
        test_base
        attr_line.tests.cc
        fs_util.tests.cc
        humanize.file_size.tests.cc
        humanize.network.tests.cc
        humanize.time.tests.cc
        intern_string.tests.cc
        lnav.gzip.tests.cc
        string_util.tests.cc
        network.tcp.tests.cc
        test_base.cc)
target_include_directories(test_base PUBLIC ../third-party/doctest-root)
target_link_libraries(test_base base pcrepp ZLIB::ZLIB)
add_test(NAME test_base COMMAND test_base)

=== debian/changelog ===
lnav (0.12.3-2) unstable; urgency=medium

  * Revert NMU upload: The support patch for loong64 is not actually applied.

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 06 Mar 2025 13:22:31 +0100

lnav (0.12.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Dandan Zhang ]
  * Add support for loong64 (Closes: #1098244)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 06 Mar 2025 12:57:21 +0100

lnav (0.12.3-1) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 24 Nov 2024 17:31:04 +0100

lnav (0.12.3-1~exp1) experimental; urgency=medium

  * New upstream version 0.12.3
  * [tests] Substitute prefix path to lnav -nf sample in expected help text

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 24 Nov 2024 16:07:21 +0100

=== debian/control ===
Source: lnav
Section: admin
Priority: optional
Maintainer: Salvatore Bonaccorso <carnil@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libarchive-dev,
 libbz2-dev,
 libcurl4-gnutls-dev,
 libgpm-dev,
 libncurses-dev,
 libpcre2-dev,
 libreadline-dev,
 libsqlite3-dev,
 openssh-client,
 re2c,
 tzdata,
 zlib1g-dev,
 xz-utils
Standards-Version: 4.7.0
Homepage: https://lnav.org
Vcs-Browser: https://salsa.debian.org/carnil/lnav
Vcs-Git: https://salsa.debian.org/carnil/lnav.git
Rules-Requires-Root: no

Package: lnav
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ncurses-based log file viewer
 The log file navigator, lnav, is an enhanced log file viewer that
 takes advantage of any semantic information that can be gleaned from
 the files being viewed, such as timestamps and log levels.  Using this
 extra semantic information, lnav can do things like interleaving
 messages from different files, generate histograms of messages over
 time, and providing hotkeys for navigating through the file.  It is
 hoped that these features will allow the user to quickly and
 efficiently zero in on problems.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Produce no debug information for mipsel builds
# to avoid FTBFS due to running out of memory,
# cf. #1021665
ifneq (,$(filter $(DEB_HOST_ARCH), mipsel))
	export DEB_CXXFLAGS_MAINT_APPEND = -g0
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --disable-static

override_dh_installchangelogs:
	dh_installchangelogs NEWS.md

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%, uversionmangle=s|-rc|~rc|" \
https://github.com/tstack/@PACKAGE@/tags \
(?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## lnav 0.12.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 set(CMAKE_CXX_STANDARD 17)
 project(
         lnav
-        VERSION 0.12.3
+        VERSION 0.12.4
         DESCRIPTION "An advanced log file viewer for the terminal."
         HOMEPAGE_URL "https://lnav.org/"
         LANGUAGES CXX C
@@ -34,6 +34,7 @@
         PkgConfig::readline
         LibArchive::LibArchive
         ZLIB::ZLIB
+        ${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/lib/libunistring.a
 )
 
 add_subdirectory(src)

=== crashd/requirements.txt ===
blinker==1.8.2
click==8.1.7
Flask==3.0.3
gunicorn==22.0.0
itsdangerous==2.2.0
Jinja2==3.1.5
MarkupSafe==2.1.5
packaging==24.0
spookyhash==2.1.0
Werkzeug==3.0.6

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/lnav.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/lnav.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/lnav"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/lnav"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== docs/requirements.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
 furo
 sphinx>=4.3.0
+sphinxcontrib-lightbox2
 sphinx-copybutton
 sphinx-jsonschema
 sphinx-prompt

=== release/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-VERSION=0.12.3
+VERSION=0.12.4
 
 VERSION_TAG=v$(VERSION)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,11 +3,14 @@
 include(CheckLibraryExists)
 include(CheckFunctionExists)
 
+add_compile_definitions(_GNU_SOURCE)
+
 check_type_size(off_t SIZEOF_OFF_T)
 
 check_include_file("pty.h" HAVE_PTY_H)
 check_include_file("util.h" HAVE_UTIL_H)
 check_include_file("execinfo.h" HAVE_EXECINFO_H)
+check_include_file("libproc.h" HAVE_LIBPROC_H)
 
 set(VCS_PACKAGE_STRING "lnav ${CMAKE_PROJECT_VERSION}")
 set(PACKAGE_VERSION "${CMAKE_PROJECT_VERSION}")
@@ -25,7 +28,7 @@
 add_executable(bin2c bin2c.hh ../tools/bin2c.c)
 target_link_libraries(bin2c ZLIB::ZLIB)
 
-add_executable(ptimec ptimec.hh ptimec.c)
+add_executable(ptimec ptimec.hh ptimec.cc)
 
 set(TIME_FORMATS
         "@%@"
@@ -86,6 +89,7 @@
         "%a %b %d %H:%M:%S.%L "
         "%a %b %d %H:%M "
         "%a %b %e %H:%M:%S %Z %Y"
+        "%d/%m/%y %H:%M:%S"
         "%d/%b/%Y:%H:%M:%S %z"
         "%d-%b-%Y %H:%M:%S %z"
         "%d-%b-%Y %H:%M:%S %Z"
@@ -115,7 +119,9 @@
         "%m/%d/%Y %H:%M:%S"
         "%d/%b/%Y %H:%M:%S"
         "%d/%b/%y %H:%M:%S"
+        "%m.%d %H:%M:%S"
         "%m%d %H:%M:%S"
+        "%y%m%d %H%M%S"
         "%Y%m%d %H:%M:%S"
         "%Y%m%d.%H%M%S"
         "%H:%M:%S"
@@ -132,8 +138,10 @@
 
 set(GEN_SRCS "")
 
-add_custom_command(OUTPUT time_fmts.cc COMMAND ptimec ${TIME_FORMATS} >
-        time_fmts.cc)
+add_custom_command(
+        OUTPUT time_fmts.cc
+        DEPENDS ptimec
+        COMMAND ptimec ${TIME_FORMATS} > time_fmts.cc)
 
 add_library(lnavdt STATIC config.h.in ptimec.hh ptimec_rt.cc time_fmts.cc)
 target_include_directories(lnavdt PUBLIC . ${CMAKE_CURRENT_BINARY_DIR} third-party/date/include)
@@ -169,6 +177,7 @@
         formats/cloudvm_ram_log.json
         formats/cups_log.json
         formats/dpkg_log.json
+        formats/ecs_log.json
         formats/elb_log.json
         formats/engine_log.json
         formats/error_log.json
@@ -189,6 +198,7 @@
         formats/page_log.json
         formats/pcap_log.json
         formats/procstate_log.json
+        formats/proxifier_log.json
         formats/redis_log.json
         formats/snaplogic_log.json
         formats/sssd_log.json
@@ -262,12 +272,18 @@
 set(BUILTIN_LNAV_SCRIPTS
         scripts/dhclient-summary.lnav
         scripts/docker-url-handler.lnav
+        scripts/find-msg.lnav
+        scripts/find-chained-msg.lnav
         scripts/journald-url-handler.lnav
+        scripts/lnav-copy-text.lnav
+        scripts/lnav-link-callback.lnav
         scripts/lnav-pop-view.lnav
         scripts/partition-by-boot.lnav
         scripts/piper-url-handler.lnav
         scripts/rename-stdin.lnav
+        scripts/report-access-log.lnav
         scripts/search-for.lnav
+        scripts/zk-set-ops.lnav
 )
 
 set(BUILTIN_LNAV_SCRIPT_PATHS ${BUILTIN_LNAV_SCRIPTS})
@@ -280,7 +296,12 @@
         DEPENDS bin2c ${BUILTIN_LNAV_SCRIPTS})
 list(APPEND GEN_SRCS builtin-scripts.h builtin-scripts.cc)
 
-set(BUILTIN_SH_SCRIPTS scripts/com.vmware.btresolver.py scripts/dump-pid.sh scripts/pcap_log-converter.sh)
+set(BUILTIN_SH_SCRIPTS
+        scripts/com.vmware.btresolver.py
+        scripts/dump-pid.sh
+        scripts/pcap_log-converter.sh
+        scripts/zookeeper.sql
+)
 
 set(BUILTIN_SH_SCRIPT_PATHS ${BUILTIN_SH_SCRIPTS})
 
@@ -322,40 +343,40 @@
 
 add_library(
         cppscnlib STATIC
-        third-party/scnlib/src/reader_float.cpp
-        third-party/scnlib/src/reader_int.cpp
-        third-party/scnlib/src/locale.cpp
-        third-party/scnlib/src/file.cpp
-        third-party/scnlib/src/vscan.cpp
-
-        third-party/scnlib/include/scn/reader/reader.h
-        third-party/scnlib/include/scn/reader/float.h
-        third-party/scnlib/include/scn/reader/types.h
-        third-party/scnlib/include/scn/reader/int.h
-        third-party/scnlib/include/scn/reader/common.h
-        third-party/scnlib/include/scn/reader/string.h
-        third-party/scnlib/include/scn/ranges/custom_impl.h
-        third-party/scnlib/include/scn/ranges/std_impl.h
-        third-party/scnlib/include/scn/ranges/ranges.h
-        third-party/scnlib/include/scn/ranges/util.h
+        third-party/scnlib/src/scn/impl.cpp
+        third-party/scnlib/src/scn/impl.h
+
         third-party/scnlib/include/scn/fwd.h
-        third-party/scnlib/include/scn/util/algorithm.h
-        third-party/scnlib/include/scn/util/small_vector.h
-        third-party/scnlib/include/scn/util/optional.h
-        third-party/scnlib/include/scn/util/expected.h
-        third-party/scnlib/include/scn/util/array.h
-        third-party/scnlib/include/scn/util/unique_ptr.h
-        third-party/scnlib/include/scn/util/math.h
-        third-party/scnlib/include/scn/util/memory.h
-        third-party/scnlib/include/scn/util/span.h
-        third-party/scnlib/include/scn/util/meta.h
-        third-party/scnlib/include/scn/util/string_view.h
-        third-party/scnlib/include/scn/unicode/unicode.h
-        third-party/scnlib/include/scn/unicode/common.h
-        third-party/scnlib/include/scn/unicode/utf16.h
-        third-party/scnlib/include/scn/unicode/utf8.h
-        third-party/scnlib/include/scn/all.h
-        third-party/scnlib/include/scn/tuple_return/tuple_return.h
-        third-party/scnlib/include/scn/tuple_return/util.h
-        third-party/scnlib/include/scn/scan/ignore.h
-        third-party/scnlib/include/scn/scan/getline.h
+        third-party/scnlib/include/scn/ranges.h
+        third-party/scnlib/include/scn/xchar.h
+        third-party/scnlib/include/scn/chrono.h
+        third-party/scnlib/include/scn/regex.h
+        third-party/scnlib/include/scn/istream.h
+        third-party/scnlib/include/scn/scan.h
+)
+target_include_directories(
+        cppscnlib PRIVATE
+        third-party/scnlib/src
+        third-party/scnlib/src/deps/fast_float/single_include)
+target_include_directories(cppscnlib PUBLIC third-party/scnlib/include)
+
+add_library(
+        base64 STATIC
+        third-party/base64/lib/lib.c
+        third-party/base64/lib/arch/generic/codec.c
+        third-party/base64/lib/tables/tables.c
+)
+target_include_directories(base64 PRIVATE third-party/base64/lib)
+target_include_directories(base64 PUBLIC third-party/base64/include)
+
+add_library(
+        lnavnotcurses STATIC
+        third-party/notcurses/src/compat/compat.c
+        third-party/notcurses/src/lib/automaton.c
+        third-party/notcurses/src/lib/blit.c
+        third-party/notcurses/src/lib/debug.c
+        third-party/notcurses/src/lib/direct.c
+        third-party/notcurses/src/lib/fade.c
+        third-party/notcurses/src/lib/fd.c
+        third-party/notcurses/src/lib/fill.c
+        third-party/notcurses/src/lib/gpm.c

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -71,17 +71,26 @@
 target_link_libraries(test_text_anonymizer diag)
 add_test(NAME test_text_anonymizer COMMAND test_text_anonymizer)
 
+add_executable(drive_readline_curses drive_readline_curses.cc test_stubs.cc)
+target_link_libraries(drive_readline_curses diag)
+
 add_executable(drive_view_colors drive_view_colors.cc test_stubs.cc)
 target_link_libraries(drive_view_colors diag)
 
 add_executable(drive_vt52_curses drive_vt52_curses.cc test_stubs.cc)
 target_link_libraries(drive_vt52_curses diag)
 
+add_executable(drive_listview drive_listview.cc test_stubs.cc)
+target_link_libraries(drive_listview diag)
+
 add_executable(drive_logfile drive_logfile.cc test_stubs.cc)
 target_link_libraries(drive_logfile diag)
 
 add_executable(drive_sql_anno drive_sql_anno.cc test_stubs.cc)
 target_link_libraries(drive_sql_anno diag)
+
+add_executable(drive_textinput drive_textinput.cc test_stubs.cc)
+target_link_libraries(drive_textinput diag)
 
 add_executable(drive_data_scanner drive_data_scanner.cc test_stubs.cc)
 target_link_libraries(drive_data_scanner diag logfmt)

=== src/base/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
         attr_line.builder.cc
         auto_fd.cc
         auto_pid.cc
+        cell_container.cc
         color_spaces.cc
         date_time_scanner.cc
         fs_util.cc
@@ -35,6 +36,7 @@
         auto_mem.hh
         auto_pid.hh
         bus.hh
+        cell_container.hh
         color_spaces.hh
         date_time_scanner.cfg.hh
         date_time_scanner.hh
@@ -57,6 +59,7 @@
         line_range.hh
         lnav.console.hh
         lnav.console.into.hh
+        lnav.resolver.hh
         log_level_enum.hh
         lrucache.hpp
         map_util.hh
@@ -70,7 +73,6 @@
         strnatcmp.h
         time_util.hh
         types.hh
-        wcwidth9.h
 
         ../third-party/xxHash/xxhash.h
         ../third-party/xxHash/xxhash.c
@@ -78,20 +80,22 @@
 
 target_include_directories(base PUBLIC . .. ../third-party
         ../third-party/date/include
-        ${CURSES_INCLUDE_DIRS}
-        ${CMAKE_CURRENT_BINARY_DIR}/..)
+        ${CMAKE_CURRENT_BINARY_DIR}/..
+)
 target_link_libraries(base
         cppfmt
         cppscnlib
         pcrepp
-        ${CURSES_LIBRARIES}
         pthread
         lnavdt
-        datepp)
+        lnavnotcurses
+        datepp
+)
 
 add_executable(
         test_base
         attr_line.tests.cc
+        cell_container.tests.cc
         fs_util.tests.cc
         humanize.file_size.tests.cc
         humanize.network.tests.cc

=== src/pcrepp/CMakeLists.txt ===
add_library(pcrepp STATIC
        ../config.h.in
        pcre2pp.hh
        pcre2pp_fwd.hh
        pcre2pp.cc)

target_include_directories(pcrepp PUBLIC . .. ../third-party/scnlib/include
        ${CMAKE_CURRENT_BINARY_DIR}/..)
target_link_libraries(pcrepp cppfmt PCRE2::8BIT PCRE2::16BIT PCRE2::32BIT PCRE2::POSIX)

add_executable(test_pcre2pp test_pcre2pp.cc)
target_include_directories(
        test_pcre2pp
        PUBLIC
        ../third-party/doctest-root)
target_link_libraries(test_pcre2pp pcrepp)
add_test(NAME test_pcre2pp COMMAND test_pcre2pp)

=== src/remote/CMakeLists.txt ===
add_library(remote STATIC ../config.h.in remote.ssh.cc remote.ssh.hh)

target_include_directories(remote PUBLIC . .. ../fmtlib
        ${CMAKE_CURRENT_BINARY_DIR}/..)
target_link_libraries(remote cppfmt)

=== src/tailer/CMakeLists.txt ===
add_library(tailercommon sha-256.c sha-256.h tailer.c tailer.h)

add_executable(tailer tailer.main.c)

target_link_libraries(tailer tailercommon)

add_library(tailerpp tailerpp.hh tailerpp.cc)
target_link_libraries(tailerpp base)

add_custom_command(
  OUTPUT tailerbin.h tailerbin.cc
  COMMAND bin2c -n tailer_bin tailerbin tailer
  DEPENDS bin2c tailer)

add_library(tailerservice tailer.looper.hh tailer.looper.cc
                          tailer.looper.cfg.hh tailerbin.h tailerbin.cc)
target_include_directories(tailerservice PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(tailerservice base)

add_executable(drive_tailer drive_tailer.cc)

target_include_directories(drive_tailer PUBLIC . .. ../fmtlib
                                               ${CMAKE_CURRENT_BINARY_DIR}/..)
target_link_libraries(drive_tailer base tailercommon tailerpp ZLIB::ZLIB)

=== src/yajlpp/CMakeLists.txt ===
add_library(
        yajlpp STATIC
        ../config.h.in
        json_op.hh
        json_ptr.hh
        yajlpp.hh
        yajlpp_def.hh

        json_op.cc
        json_ptr.cc
        yajlpp.cc
)

target_include_directories(yajlpp PUBLIC . .. ../fmtlib
        ${CMAKE_CURRENT_BINARY_DIR}/..)
target_link_libraries(yajlpp
        pcrepp
        yajl
        ${CURSES_LIBRARIES}
        datepp
)

add_executable(test_yajlpp test_yajlpp.cc)
target_link_libraries(test_yajlpp yajlpp base ${lnav_LIBS})
add_test(NAME test_yajlpp COMMAND test_yajlpp)

add_executable(test_json_ptr test_json_ptr.cc)
target_link_libraries(test_json_ptr yajlpp base ${lnav_LIBS})
add_test(NAME test_json_ptr COMMAND test_json_ptr)

add_executable(drive_json_op drive_json_op.cc)
target_link_libraries(drive_json_op base yajlpp ${lnav_LIBS})

=== debian/changelog ===
lnav (0.12.4-2) unstable; urgency=medium

  * Upload to unstable
  * debian/watch: Convert to uscan version 5

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 20 Sep 2025 17:35:51 +0200

lnav (0.12.4-2~exp1) experimental; urgency=medium

  * [notcurses] handle failure to set cregs from tmux (Closes: #1109004)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 29 Jul 2025 19:38:42 +0200

lnav (0.12.4-1) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 23 Mar 2025 20:37:34 +0100

lnav (0.12.4-1~exp3) experimental; urgency=medium

  * Correct disabling of test_sql_json_func.sh test

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 23 Mar 2025 16:38:45 +0100

lnav (0.12.4-1~exp2) experimental; urgency=medium

  * Add loongarch64 support (Closes: #1098244)
  * Disable broken test_sql_indexes.sh test
  * Declare compliance with Debian policy 4.7.2

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 23 Mar 2025 15:41:00 +0100

lnav (0.12.4-1~exp1) experimental; urgency=medium

  * New upstream version 0.12.4
  * debian/control: Add Build-Depends on libunistring-dev
  * Update copyright years for upstream files
  * Update copyright years for debian/* packaging files
  * Disable test_cmds.sh test

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 18 Feb 2025 20:29:10 +0100

=== debian/watch ===
Version: 5
Source: https://github.com/tstack/@PACKAGE@/tags
Matching-Pattern: (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%
Uversionmangle: s|-rc|~rc|

## lnav 0.13.2

=== debian/changelog ===
lnav (0.13.2-1~exp1) experimental; urgency=medium

  * New upstream version 0.13.2
  * lnav/docs: Install help.md instead of dropped help.txt into docs
  * debian/control: Drop Build-Depends on libncurses-dev
  * Revert "Produce no debug information for mipsel builds" (mipsel not
    anymore in Debian)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 29 Nov 2025 17:53:30 +0100

=== debian/control ===
--- 
+++ 
@@ -8,16 +8,16 @@
  libbz2-dev,
  libcurl4-gnutls-dev,
  libgpm-dev,
- libncurses-dev,
  libpcre2-dev,
  libreadline-dev,
  libsqlite3-dev,
+ libunistring-dev,
  openssh-client,
  re2c,
  tzdata,
  zlib1g-dev,
  xz-utils
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://lnav.org
 Vcs-Browser: https://salsa.debian.org/carnil/lnav
 Vcs-Git: https://salsa.debian.org/carnil/lnav.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --disable-static

override_dh_installchangelogs:
	dh_installchangelogs NEWS.md
